// SkypeDecoderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SkypeDecoder.h"
#include "SkypeDecoderDlg.h"
#include "Winsock2.h"
#include <Mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSkypeDecoderDlg dialog




CSkypeDecoderDlg::CSkypeDecoderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSkypeDecoderDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSkypeDecoderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSkypeDecoderDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CSkypeDecoderDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CSkypeDecoderDlg message handlers

BOOL CSkypeDecoderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSkypeDecoderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSkypeDecoderDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSkypeDecoderDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



// XXX -------------------Da qui in poi c'e' il codice del decoder-------------------------
#include "speex/speex.h"
#include <stdio.h>

typedef void *(*speex_decoder_init_t)(SpeexMode *);
typedef int (*speex_decoder_ctl_t)(void *, int, void *);
typedef int (*speex_decode_t)(void *, SpeexBits *, float *);
typedef SpeexMode *(*speex_lib_get_mode_t)(int);
typedef void (*speex_bits_read_from_t)(SpeexBits *, char *, int);
typedef void (*speex_bits_init_t)(SpeexBits *);
typedef void (*speex_decoder_destroy_t)(void *);
typedef void (*speex_bits_destroy_t)(SpeexBits *);

speex_decoder_init_t rel_speex_decoder_init;
speex_decoder_ctl_t rel_speex_decoder_ctl;
speex_decode_t rel_speex_decode;
speex_lib_get_mode_t rel_speex_lib_get_mode;
speex_bits_read_from_t rel_speex_bits_read_from;
speex_bits_init_t rel_speex_bits_init;
speex_decoder_destroy_t rel_speex_decoder_destroy;
speex_bits_destroy_t rel_speex_bits_destroy;

HMODULE hcodec;

#define SAFE_FREE(x) {if(x) free(x); x= NULL;}
#define EXTENSION ".wav"  // Estensione dei file encodati (XXX Bisognerebbe cambiarla in .enc)
#define SAMPLE_RATE 48000
#define CALL_DELTA 19 // Differenza oltre la quale considera una diversa chiamata

typedef struct wave_list {
	DWORD init_time[2];
	DWORD end_time[2];
	char file_name[_MAX_PATH];
	char user_name[_MAX_PATH];
	struct wave_list *next;
} wave_list_struct;
wave_list_struct *wave_list_head[2] = {NULL, NULL};

typedef struct call_list {
	DWORD init_time[2];
	DWORD end_time[2];
	wave_list_struct *first;
	wave_list_struct *last;
	char user_name[_MAX_PATH];
	struct call_list *next;
} call_list_struct;
call_list_struct *call_list_head[2] = {NULL, NULL};

#define INPUT_LIST 1
#define OUTPUT_LIST 0
#define HI_PART 0
#define LOW_PART 1

typedef struct file_elem {
	DWORD init_time[2];
	DWORD end_time[2];
	char user_name[_MAX_PATH];
	char *file_name;
} file_elem_struct;



BOOL ResolveSymbols()
{
	// XXX Qui usavo la libreria STABLE e non quella che si uploada 
	// sul client. 
	if ( !(hcodec = LoadLibrary("codecold.dll")))
		return FALSE;

	if (! (rel_speex_decoder_init = (speex_decoder_init_t)GetProcAddress(hcodec, "speex_decoder_init")) ) return FALSE;
	if (! (rel_speex_decoder_ctl = (speex_decoder_ctl_t)GetProcAddress(hcodec, "speex_decoder_ctl")) ) return FALSE;
	if (! (rel_speex_decode = (speex_decode_t)GetProcAddress(hcodec, "speex_decode")) ) return FALSE;
	if (! (rel_speex_bits_read_from = (speex_bits_read_from_t)GetProcAddress(hcodec, "speex_bits_read_from")) ) return FALSE;
	if (! (rel_speex_lib_get_mode = (speex_lib_get_mode_t)GetProcAddress(hcodec, "speex_lib_get_mode")) ) return FALSE;	
	if (! (rel_speex_bits_init = (speex_bits_init_t)GetProcAddress(hcodec, "speex_bits_init")) ) return FALSE;
	if (! (rel_speex_decoder_destroy = (speex_decoder_destroy_t)GetProcAddress(hcodec, "speex_decoder_destroy")) ) return FALSE;
	if (! (rel_speex_bits_destroy = (speex_bits_destroy_t)GetProcAddress(hcodec, "speex_bits_destroy")) ) return FALSE;
	return TRUE;
}

void CloseCodec()
{
	FreeLibrary(hcodec);
}


void WriteWavHeader(FILE *fout, DWORD size)
{
   	WAVEFORMATEX pcmWaveFormat;
	DWORD dwFileSize = size + 44; 
	DWORD dwNum = size;
	DWORD dwFmtSize = 16;

	pcmWaveFormat.wFormatTag = WAVE_FORMAT_PCM;
	pcmWaveFormat.nChannels = 2;
	pcmWaveFormat.nSamplesPerSec = SAMPLE_RATE;
	pcmWaveFormat.wBitsPerSample = 16;
	pcmWaveFormat.cbSize = 0;
	pcmWaveFormat.nBlockAlign = (pcmWaveFormat.wBitsPerSample/8)*pcmWaveFormat.nChannels;
	pcmWaveFormat.nAvgBytesPerSec = pcmWaveFormat.nSamplesPerSec*pcmWaveFormat.nBlockAlign;

	fwrite((BYTE *)"RIFF", 4, 1, fout) ;
	fwrite((BYTE *)&dwFileSize, sizeof(dwFileSize), 1, fout) ;
	fwrite((BYTE *)"WAVEfmt ", 8, 1, fout) ;
	fwrite((BYTE *)&dwFmtSize, sizeof(dwFmtSize), 1, fout) ;
	fwrite((BYTE *)&pcmWaveFormat.wFormatTag, sizeof(pcmWaveFormat.wFormatTag), 1, fout) ;
	fwrite((BYTE *)&pcmWaveFormat.nChannels, sizeof(pcmWaveFormat.nChannels), 1, fout) ;
	fwrite((BYTE *)&pcmWaveFormat.nSamplesPerSec, sizeof(pcmWaveFormat.nSamplesPerSec), 1, fout) ;
	fwrite((BYTE *)&pcmWaveFormat.nAvgBytesPerSec, sizeof(pcmWaveFormat.nAvgBytesPerSec), 1, fout) ;
	fwrite((BYTE *)&pcmWaveFormat.nBlockAlign, sizeof(pcmWaveFormat.nBlockAlign), 1, fout) ;
	fwrite((BYTE *)&pcmWaveFormat.wBitsPerSample, sizeof(pcmWaveFormat.wBitsPerSample), 1, fout) ;
	fwrite((BYTE *)"data", 4, 1, fout) ;
	fwrite((BYTE *)&dwNum, sizeof(dwNum), 1, fout) ;
}


// Torna 0 o 1 a seconda della lista. Torna -1 se fallisce
int ParseFileName(char *file_name, file_elem_struct *file_elem)
{
	char local_name[MAX_PATH];
	char end_low[9], end_hi[9];
	char init_low[9], init_hi[9];
	int ret_val = -1;
	char *ptr;

	sprintf(local_name, "%s", file_name);
	if ( !(ptr = strstr(local_name, EXTENSION)) )
		return -1;

	end_low[8]=end_hi[8]=init_low[8]=init_hi[8]=0;
	ptr -= 17;
	ptr -= 8; memcpy(end_low, ptr, 8);
	ptr -= 8; memcpy(end_hi, ptr, 8);
	ptr -= 9; memcpy(init_low, ptr, 8);
	ptr -= 8; memcpy(init_hi, ptr, 8);
	sscanf(end_low, "%X", &file_elem->end_time[LOW_PART]);
	sscanf(end_hi, "%X", &file_elem->end_time[HI_PART]);
	sscanf(init_low, "%X", &file_elem->init_time[LOW_PART]);
	sscanf(init_hi, "%X", &file_elem->init_time[HI_PART]);
	file_elem->file_name = file_name;
	
	ptr-=2; 
	if (*ptr == 'T') //OUT
		ret_val = OUTPUT_LIST;
	else if (*ptr == 'N')
		ret_val =  INPUT_LIST;
	else 
		return -1;

	*ptr = 0;
	sprintf(file_elem->user_name, "%s", local_name+11);
	ptr = strrchr(file_elem->user_name, '_');
	*ptr = 0;

	return ret_val;
}

// Torna TRUE se il primo elemento e' maggiore del secondo
BOOL IsGreaterLong(DWORD *elem_1, DWORD *elem_2)
{
	if (elem_1[HI_PART] > elem_2[HI_PART])
		return TRUE;
	if (elem_1[HI_PART] < elem_2[HI_PART])
		return FALSE;
	if (elem_1[LOW_PART] > elem_2[LOW_PART])
		return TRUE;
	return FALSE;
}

// Sottrae la seconda alla prima e torna la differenza in decimi di secondo
int DiffLong(DWORD *elem_1, DWORD *elem_2)
{
	long long elem64_1=0, elem64_2=0;
	int diff;

	elem64_1 = elem_1[HI_PART]; elem64_1<<=32;
	elem64_2 = elem_2[HI_PART]; elem64_2<<=32;
	elem64_1 += elem_1[LOW_PART];
	elem64_2 += elem_2[LOW_PART];
	elem64_1 -= elem64_2;
	elem64_1 /= 1000000;
	diff = (int) elem64_1;

	return diff;
}

// Alloca e inserisce un nuovo elemento in ordine di sequenza a seconda del nome
BOOL InsertList(wave_list_struct **wave_list, file_elem_struct *file_elem)
{
	wave_list_struct *new_elem;
	
	// Cerca l'elemento dove va inserito
	while (*wave_list) {
		// Se abbiamo trovato il posto giusto si ferma
		if (IsGreaterLong((*wave_list)->init_time, file_elem->init_time))
			break;
		// Continua a scorrere la lista
		wave_list = &( (*wave_list)->next );
	}

	// Alloca e inizializza il nuovo elemento
	if ( !(new_elem = (wave_list_struct *)malloc(sizeof(wave_list_struct))) )
		return FALSE;

	new_elem->next = *wave_list;
	memcpy(new_elem->init_time, file_elem->init_time, 2*sizeof(DWORD));
	memcpy(new_elem->end_time, file_elem->end_time, 2*sizeof(DWORD));
	sprintf_s(new_elem->file_name, _MAX_PATH, "%s", file_elem->file_name);
	sprintf_s(new_elem->user_name, _MAX_PATH, "%s", file_elem->user_name);
	*wave_list = new_elem;
	
	return TRUE;
}

// Completa il path aggiungendo il nome della directory
// dove si trovano i file encodati.
// XXX Devo mettere il path corretto
char *CompletePath(char *filename)
{
	static char path[MAX_PATH];
	sprintf(path, "C:\\SKYPE\\%s", filename);
	return path;
}

// Libera la lista dei sample
void FreeWaveList(wave_list_struct **wave_list)
{
	wave_list_struct *list_ptr, *tmp_ptr;
	list_ptr = *wave_list;
	while(list_ptr) {
		tmp_ptr = list_ptr->next;
		SAFE_FREE(list_ptr);
		list_ptr = tmp_ptr;
	}
	*wave_list = NULL;
}

// Libera la lista delle chiamate
void FreeCallList(call_list_struct **call_list)
{
	call_list_struct *list_ptr, *tmp_ptr;
	list_ptr = *call_list;
	while(list_ptr) {
		tmp_ptr = list_ptr->next;
		SAFE_FREE(list_ptr);
		list_ptr = tmp_ptr;
	}
	*call_list = NULL;
}

// Crea la lista delle chiamate 
void ParseSampleList(wave_list_struct *wave_list, call_list_struct **call_list)
{
	char *LastCallID = "NO.CALLER:\\";
	DWORD diff_time = 0;

	while(wave_list) {
		// Se cambia CallerID o c'e' molta distanza fra i sample, 
		// lo considera una chiamata differente.
		// La considera differente anche se il termine attuale della chiamata
		// differisce di molto dall'inizio del campione successivo
		if (*call_list)
			diff_time = abs(DiffLong((*call_list)->end_time, wave_list->init_time));
		if (strcmp(LastCallID, wave_list->user_name) || diff_time>CALL_DELTA) {
			LastCallID = wave_list->user_name;
			// Lo sposta sul successivo se non si trova sulla testa
			if (*call_list)
				call_list = &( (*call_list)->next );

			// Crea una nuova chiamata
			*call_list = (call_list_struct *)malloc(sizeof(call_list_struct));
			if (! *call_list)
				return;
	
			// Definisce la telefonata in corso (tranne la fine...)
			sprintf((*call_list)->user_name, "%s" ,wave_list->user_name);
			memcpy((*call_list)->init_time, wave_list->init_time, 2*sizeof(DWORD));
			(*call_list)->first = wave_list;
			(*call_list)->next = NULL;
		}
		// Setta l'ultimo su quello corrente finche' non cambia telefonata
		(*call_list)->last = wave_list;
		memcpy((*call_list)->end_time, wave_list->end_time, 2*sizeof(DWORD));

		wave_list = wave_list->next;
	}
}


// Cerca il primo canale relativo a quello passato
// che si intersechi temporalmente
call_list_struct *FindSecondChannel(call_list_struct *main_chan)
{
	call_list_struct *channel_list = call_list_head[INPUT_LIST];
	while(channel_list) {
		// Si interseca?
		if (IsGreaterLong(channel_list->end_time, main_chan->init_time) &&
			IsGreaterLong(main_chan->end_time, channel_list->init_time))
			break;
		channel_list = channel_list->next;
	}

	return channel_list;
}

// ------------------ Funzioni e dati relativi allo streaming -------------------
wave_list_struct *sample_start[2], *sample_stop[2];
DWORD static_blank_samples[2];
DWORD static_framesize;
FILE *chan_file[2];
void InitStream(call_list_struct *channel1_list, call_list_struct *channel2_list, DWORD *blank_samples, DWORD FRAME_SIZE)
{
	sample_start[OUTPUT_LIST] = channel1_list->first;
	sample_stop[OUTPUT_LIST] = channel1_list->last;

	// potrebbe non esistere il secondo canale
	if (channel2_list) {
		sample_start[INPUT_LIST] = channel2_list->first;
		sample_stop[INPUT_LIST] = channel2_list->last;
	} else {
		sample_start[INPUT_LIST] = NULL;
		sample_stop[INPUT_LIST] = NULL;
	}

	static_blank_samples[OUTPUT_LIST] = blank_samples[OUTPUT_LIST];
	static_blank_samples[INPUT_LIST] = blank_samples[INPUT_LIST];
	chan_file[OUTPUT_LIST] = NULL;
	chan_file[INPUT_LIST] = NULL;
	static_framesize = FRAME_SIZE;
}

// Legge un frame da uno stream di file encodati
char *StreamRead(DWORD list, DWORD *nbBytes)
{
	static char buffer[2048];

	// Se ha finito di leggere da quel dato stream
	if (!sample_start[list])
		return NULL;

	// Se ancora quel dato stream non deve partire...
	if (static_blank_samples[list] > static_framesize) {
		static_blank_samples[list] -= static_framesize;
		return NULL;
	} else
		static_blank_samples[list] = 0;

	// Se non ha ancora aperto un file, o se quello letto e' finito,
	// apre un nuovo file
	if (!chan_file[list] || fread(nbBytes, 4, 1, chan_file[list])!=1) {
		// Se c'era un file aperto lo chiude e va avanti
		if (chan_file[list]) {
			fclose(chan_file[list]);
			// Se il campione letto era l'utlimo della lista, azzera tutto
			// per poi smettere di leggere
			if (sample_start[list] == sample_stop[list]) {
				sample_start[list] = NULL;
				return NULL;
			}
			// Altrimenti passa all'elemento successivo in lista
			sample_start[list] = (sample_start[list])->next;
		} 
		chan_file[list] = fopen(CompletePath((sample_start[list])->file_name), "rb");
		if (!chan_file[list])
			return NULL;
		// ritenta la lettura 
		fread(nbBytes, 4, 1, chan_file[list]);
	}

	// Legge i dati da file
	fread(buffer, *nbBytes, 1, chan_file[list]);
	return buffer;
}
// ------------------------------------------------------------------------------


// Scrive la telefonata N-esima su file
BOOL WriteCall(DWORD index, char *filename)
{
	FILE *fout;
	float decoded_in[1024];
	float decoded_out[1024];
	char *cbits_in, *cbits_out; // puntatore al sample da decodare 
	DWORD nbBytes;
	void *state_in, *state_out;
	SpeexBits bits_in, bits_out;
	DWORD i, j, tmp;
	DWORD FRAME_SIZE;
	DWORD size = 0;
	DWORD rate = SAMPLE_RATE;
	call_list_struct *channel1_list = call_list_head[OUTPUT_LIST];
	call_list_struct *channel2_list;
	int time_delta;
	DWORD blank_samples[2] = {0,0};

	// Controllo paranoico
	if (!channel1_list) 
		return FALSE;

	// Scorre fino alla n-esima chiamata
	for(j=0; j<index; j++) {
		channel1_list = channel1_list->next;
		if (!channel1_list)
			return FALSE;
	}

	// Cerca l'altro canale relativo a questa chiamata
	channel2_list = FindSecondChannel(channel1_list);

	// Calcola la differenza di tempo per la sincronizzazione fra
	// i due canali (in decimi di secondo)
	// Se non c'e' l'altro canale la differenza e' messa a 0
	// e la lista dei sample punta a NULL 
	if (channel2_list) {
		time_delta = DiffLong(channel1_list->init_time, channel2_list->init_time);
		// Calcola il numero di sample da suonare a vuoto per entrambi i canali
		if (time_delta > 0)
			blank_samples[OUTPUT_LIST] = time_delta * (SAMPLE_RATE/10);
		else 
			blank_samples[INPUT_LIST] = abs(time_delta) * (SAMPLE_RATE/10);
	}

	// ------ Comincia a scrivere il WAV --------------------------------
	if ( !(fout = fopen(filename, "wb")) )
		return FALSE;
	state_in = rel_speex_decoder_init(rel_speex_lib_get_mode(2));
	state_out = rel_speex_decoder_init(rel_speex_lib_get_mode(2));
	tmp=1;
	rel_speex_decoder_ctl(state_in, SPEEX_SET_ENH, &tmp);
	rel_speex_decoder_ctl(state_in, SPEEX_GET_FRAME_SIZE, &FRAME_SIZE);
	rel_speex_decoder_ctl(state_out, SPEEX_SET_ENH, &tmp);
	rel_speex_decoder_ctl(state_out, SPEEX_GET_FRAME_SIZE, &FRAME_SIZE);

	// Scrive un header provvisorio
	WriteWavHeader(fout, 0);
	rel_speex_bits_init(&bits_in);
	rel_speex_bits_init(&bits_out);

	// Ciclo di scrittura dei campioni....
	// Inizializza la lettura degli stream (mascherano l'apertura dei file in lista)
	InitStream(channel1_list, channel2_list, blank_samples, FRAME_SIZE);
	while (1) {
		// Se torna NULL non ha piu' da leggere da quello stream
		if (cbits_in = StreamRead(INPUT_LIST, &nbBytes)) {
			rel_speex_bits_read_from(&bits_in, cbits_in, nbBytes);
			rel_speex_decode(state_in, &bits_in, decoded_in);
		} else // Se non e' ancora partito o ha finito i sample, mette del silenzio
			for (i=0;i<FRAME_SIZE;i++) 
				decoded_in[i]=0;

		// Fa lo stesso per il secondo canale
		if (cbits_out = StreamRead(OUTPUT_LIST, &nbBytes)) {
			rel_speex_bits_read_from(&bits_out, cbits_out, nbBytes);
			rel_speex_decode(state_out, &bits_out, decoded_out);
		} else // Se non e' ancora partito o ha finito i sample, mette del silenzio
			for (i=0;i<FRAME_SIZE;i++) 
				decoded_out[i]=0;

		// Se entrambi i canali hanno finito, chiude il file
		if (!cbits_out && !cbits_in)
			break;

		// Scrive i sample decodificati in maniera interleaved
		for (i=0;i<FRAME_SIZE;i++) {
			short tmp_sample;
			tmp_sample = (short)decoded_in[i];
			fwrite(&tmp_sample, sizeof(short), 1, fout);
			tmp_sample = (short)decoded_out[i];
			fwrite(&tmp_sample, sizeof(short), 1, fout);
		}

		// Aumenta la dimensione totale del file
		size += FRAME_SIZE*2*2; // 2 canali da 16 bit per ogni frame
	}

	// Scrive l'header Vero e resetta il codec
	fseek(fout, 0, SEEK_SET);
	WriteWavHeader(fout, size);
	rel_speex_decoder_destroy(state_in);
	rel_speex_bits_destroy(&bits_in);
	rel_speex_decoder_destroy(state_out);
	rel_speex_bits_destroy(&bits_out);
	fclose(fout);
	return TRUE;
}

void CSkypeDecoderDlg::OnBnClickedOk()
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind = INVALID_HANDLE_VALUE;
	file_elem_struct file_elem;
	char wildcard[16];
	int list;

	// Carica la libreria 
	if (!ResolveSymbols())
		return;

	// Crea le due liste di campioni
	sprintf(wildcard, "*%s", EXTENSION);
	hFind = FindFirstFile(CompletePath(wildcard), &FindFileData);
	if (hFind != INVALID_HANDLE_VALUE) {
		do {
			if ( (list = ParseFileName(FindFileData.cFileName, &file_elem)) == -1 )
				continue;
			InsertList(&wave_list_head[list], &file_elem);
		} while (FindNextFile(hFind, &FindFileData) != 0);
		FindClose(hFind);
	}

	// Crea le due liste di telefonate
	ParseSampleList(wave_list_head[OUTPUT_LIST], &call_list_head[OUTPUT_LIST]);
	ParseSampleList(wave_list_head[INPUT_LIST], &call_list_head[INPUT_LIST]);

	// XXX A QUESTO PUNTO PER VISUALIZZARE LA LISTA DELLE CHIAMATE, BISOGNA SCORRERE LA LISTA
	// wave_list_head[OUTPUT_LIST], CON IL CAMPO wave_list_head[OUTPUT_LIST]->user_name.
	// La INPUT_LIST non la toccare.

	// XXX Scrive la chiamata n-esima (la prima e' la numero 0)
	// Puoi ripetere la chiamata quante volte vuoi
	WriteCall(4, CompletePath("TELEFONATA.wav"));

	// Quando ha finito tutto libera la lista delle chiamate
	// che si e' costruito.
	FreeWaveList(&wave_list_head[OUTPUT_LIST]);
	FreeWaveList(&wave_list_head[INPUT_LIST]);
	FreeCallList(&call_list_head[OUTPUT_LIST]);
	FreeCallList(&call_list_head[INPUT_LIST]);

	CloseCodec();

	OnOK();
}
